/*
 * Author:          Patrick-Christopher Mattulat
 * Co-Author:       Claude Sonnet 4.6 (LLM)
 * Company:         Lynar Studios
 * E-Mail:          webmaster@lynarstudios.com
 * Created:         2021-05-01
 * Changed:         2026-06-23
 *
 * */

#include <gtest/gtest.h>
#include <ls-std/ls-std-core.hpp>
#include <string>

using ls::standard::core::IllegalArgumentException;
using std::string;
using testing::Test;

namespace
{
  class IllegalArgumentExceptionTest : public Test
  {
    public:

      IllegalArgumentExceptionTest() = default;
      ~IllegalArgumentExceptionTest() override = default;
  };

  TEST_F(IllegalArgumentExceptionTest, constructor)
  {
    EXPECT_THROW(
        {
          try
          {
            throw IllegalArgumentException{};
          }
          catch (const IllegalArgumentException &_exception)
          {
            const string actual = _exception.what();
            const string expected = _exception.getName() + " thrown - passed argument is not valid!";

            EXPECT_STREQ(expected.c_str(), actual.c_str());
            throw;
          }
        },
        IllegalArgumentException);
  }

  TEST_F(IllegalArgumentExceptionTest, constructor_dedicated_message)
  {
    EXPECT_THROW(
        {
          try
          {
            throw IllegalArgumentException{"value is empty"};
          }
          catch (const IllegalArgumentException &_exception)
          {
            const string actual = _exception.what();
            const string expected = _exception.getName() + " thrown - value is empty";

            EXPECT_STREQ(expected.c_str(), actual.c_str());
            throw;
          }
        },
        IllegalArgumentException);
  }

  TEST_F(IllegalArgumentExceptionTest, getName)
  {
    ASSERT_STREQ("IllegalArgumentException", IllegalArgumentException{}.getName().c_str());
  }
}
